{
  "openapi": "3.1.0",
  "info": {
    "title": "Recharge API",
    "version": "2021-11",
    "description": "Recharge API reference, version 2021-11. The current version of the Recharge API. Cursor pagination, payment methods and plans."
  },
  "servers": [
    {
      "url": "https://api.rechargeapps.com"
    }
  ],
  "security": [
    {
      "apiToken": []
    }
  ],
  "tags": [
    {
      "name": "Addresses",
      "description": "An Addresses record represents a shipping address. Each customer can have multiple addresses. Subscriptions are a child object of an address."
    },
    {
      "name": "Bundle Selections",
      "description": "A bundle selection represents the contents within a Bundle linked to an individual Subscription. It can represent the selection for upcoming orders or past orders. A BundleSelection is associated with a corresponding Subscription and a BundleVariant (the BundleVariant is used to validate contents in the selection). When a new order for the associated Subscription occurs, it will extract the current contents of the BundleSelection for the Bundle item in the order."
    },
    {
      "name": "Charges",
      "description": "A charge is the representation of a financial transaction linked to the purchase of an item (past or future). It can be a transaction that was processed already or the representation of an upcoming transaction. A Charge is linked to its corresponding Orders (one Order for pay as you go subscriptions and several for pre-paid). Orders are created once the corresponding Charge is successful. After successful payment, the first Order will be immediately submitted to the external platform if applicable (e.g. Shopify, BigCommerce)."
    },
    {
      "name": "Checkouts",
      "description": "Checkouts allow you to create, update, and process a Checkout programmatically. Shipping cost and sales tax determination are automatic functions of the Recharge Checkout resource. Related guides: Recharge checkout integrations , How to use the Checkout resource Important - The Checkout endpoints are only available for BigCommerce and Custom. Checkouts on Shopify must go through Shopify."
    },
    {
      "name": "Collections",
      "description": "Collections allow to create and manage a logical list of Products called a Collection . A Collection contains an ordered list of Products and can be used for selective display of Products on chosen interfaces or for business logic automation (e.g. Discounts definition...)."
    },
    {
      "name": "Credits",
      "description": "The Credit Account object represents a set of positive and negative credit adjustments that when summed equal an available balance. Credit accounts may not have negative balances. A credit account may be associated with a customer, via the customer_id attribute. A customer may be associated with many credit accounts. A credit adjustment represents a financial adjustment to the balance of a Credit Account. An adjustment of type ‘credit’ results in an increase in the available balance of a credit account, where an adjustment of type ‘debit’ results in a decrease. Access to the Credits endpoints are only available for merchants using Retain ."
    },
    {
      "name": "Customers",
      "description": "The Customer object holds account information. Email is unique on the Customer ; no two customers for a store can have the same email. Address is a child of the Customer object. There can be many child Addresses on a customer, but only one parent Customer per Address ."
    },
    {
      "name": "Discounts",
      "description": "Discounts can be applied to a Checkout , or can be applied directly to an Address . Depending on configuration they allow for single use, or recurring discounts. More details on how to add or remove discounts from an Address can be found at Update an address . Often discounts can be used in combination with webhooks, such that when a specific event occurs, it can apply a discount dependent on custom business logic. There are various options that can be utilized for discounts such as minimum price, single use, recurring for a set number of charges, or ongoing. You can also set the date from which time the discount will become applicable and when it can no longer be applied to a new subscription."
    },
    {
      "name": "Entitlements",
      "description": "A Customer Entitlement represents access to a specific entitlement feature granted to a customer, typically driven by an active subscription. While you own and host your content, Recharge provides the logic engine that determines a customer's real-time access status based on their active subscriptions."
    },
    {
      "name": "Metafields",
      "description": "Metafields allow users to add additional information to other resources. They can be used for adding custom fields to objects, and are useful for storing specialized information."
    },
    {
      "name": "Notifications",
      "description": "The Customer Notifications resource is used to dispatch email notifications to customers within Recharge. The endpoint uses your configured Recharge email templates, and will dispatch an email to the address associated with the indicated customer_id . Some email templates require variable values, which are sent through the Customer Notifications resource via the template_vars attribute. See below examples for all available template types."
    },
    {
      "name": "Onetimes",
      "description": "Onetimes represent non-recurring line items on a QUEUED Charge ."
    },
    {
      "name": "Orders",
      "description": "An order is created after a Charge is successfully processed. The Order contains all the same json data as the Charge . In case of a prepaid order creation, the order will be queued for a particular date and submitted on that date to the external platform."
    },
    {
      "name": "Payment methods",
      "description": "The Payment Method object holds payment and billing information. A Customer may be associated with many Payment Methods , and an Addresses record must be associated with at least one Payment_method . Important - If you see the following error when accessing Payment Methods endpoints: \"You do not have sufficient permissions (scopes) for this object\", the token you are using has not been configured with correct access permissions. Update the token to have \"Read access\" or \"Read and Write access\" depending on your use case."
    },
    {
      "name": "Plans",
      "description": "The Plans resource is used to create and configure the transactional options for the Product (subscription, prepaid, and onetime purchase options) in Recharge."
    },
    {
      "name": "Products",
      "description": "Representation of the Products from your catalog in Recharge."
    },
    {
      "name": "Store",
      "description": "The store endpoint includes ReCharge settings and other store specific information."
    },
    {
      "name": "Subscriptions",
      "description": "Subscriptions are individual items a customer receives on a recurring basis. A Subscription is a Product added to an Address ."
    },
    {
      "name": "Webhook endpoints",
      "description": "Webhooks are a mechanism for reacting to specific events that are triggered in the Recharge system. For example, a checkout completion, a customer activation or subscription cancellation. Webhooks will deliver you the data of the specific event in real-time. This data can be used to custom code logic behind automated subscription management, dashboards creation, discounts applying... When a webhook is triggered, the payload will be identical to the payload you would receive from another API endpoint. For example, a webhook on subscription/created will be identical to the payload for retrieving a subscription by ID from the Recharge API. There are a lot of things that can be done via Webhooks: It can be used to collect all kinds of data from our API and then create a custom Dashboard to show how much and when your customers are buying in real time, or use all this data to do Analytics of some kind in order to create a better customer experience. Webhooks can be used as a “Trigger” on your backend to update subscription products. If you have some kind of a Subscription where you want to change the Product that the customer gets every month, you can do it by waiting for an order/created webhook on your backend, and when it fires you can make an API call to change the Product of that subscription or the next shipping date, etc. Retries / Idempotency Due to webhook retries, it’s possible that your application receives the same webhook more than once. Ensure idempotency of the webhook call by detecting such duplicates within your application. Respond to a webhook Your webhook acknowledges that it received data by sending a 200 OK response. Any response outside of the 200 range will let Recharge know that you didn’t receive your webhook. Recharge has implemented a 5 second time-out period. We wait 5 seconds, if our system doesn’t get a response in that period we consider that request as failed. Our system will try 20 times to send the same webhook over the next 2 days, if the request fails every time our system will delete this webhook. At this moment our system is logging those deleted webhooks."
    },
    {
      "name": "Async batch Endpoints",
      "description": "The Async batches API can be used for processing large volumes of operations asynchronously, in order to reduce aggregate processing time and network traffic when interacting with many unique objects. For example, a user can leverage async_batches to create 1000 discounts with only 3 API requests. As shown in the diagram below, the necessary steps to create and process a batch are: 1. Create an async_batch with the desired batch_type 2. Add tasks (individual operations) to your batch. You can add up to 1,000 tasks with each request, up to 10,000 tasks per batch. 3. Submit the batch for processing. Until a batch is submitted for processing, no tasks are attempted. 4. You may retrieve the batch to view progress details while it processes, or register for the async_batch/processed webhook to receive immediate notification of batch completion. 5. Page through the tasks in the batch to view results of each completed or failed task. Related guides: Examples of Async batches"
    },
    {
      "name": "Async batch Tasks",
      "description": "Most commonly, the response from listing tasks on an async_batch id will be identical to the body of a singular request to standard Recharge API endpoints. However, in some instances there are variations from the standard list task response body. See below for examples corresponding to each batch_type. Related guides: Examples of async batches"
    },
    {
      "name": "Token information",
      "description": "This resource allows a caller to inspect basic information regarding the token in use. It will only return a single object related to the calling token ( ie - a call with api_token.id=1 will only return information regarding api_token.id=1 ."
    },
    {
      "name": "Accounts",
      "description": "This resource allows a caller to inspect basic information regarding the staff accounts in the store."
    },
    {
      "name": "Events",
      "description": "This resource allows a caller to inspect recent events in the store."
    }
  ],
  "paths": {
    "/addresses": {
      "post": {
        "operationId": "create_address",
        "summary": "Create an address",
        "description": "Create a new address for a customer.",
        "tags": [
          "Addresses"
        ],
        "responses": {
          "201": {
            "description": "OK: The request was successful, created a new resource, and resource created is in the body.",
            "content": {
              "application/json": {
                "example": {
                  "address": {
                    "id": 42171447,
                    "address1": "1030 Barnum Ave",
                    "address2": "Suite 101",
                    "city": "Stratford",
                    "company": "Fake Company",
                    "country_code": "US",
                    "created_at": "2022-10-12T20:16:09+00:00",
                    "customer_id": 37657002,
                    "discounts": [],
                    "first_name": "Fake First",
                    "last_name": "Fake Last",
                    "order_attributes": [
                      {
                        "name": "custom name",
                        "value": "custom value"
                      }
                    ],
                    "order_note": "My recurring order note",
                    "phone": "999-999-9999",
                    "presentment_currency": "USD",
                    "province": "Connecticut",
                    "shipping_lines_conserved": [],
                    "shipping_lines_override": [],
                    "updated_at": "2022-10-12T20:16:09+00:00",
                    "zip": "06614"
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "customer_id": {
                    "type": "integer",
                    "description": "Unique numeric identifier for the customer associated with the address."
                  },
                  "address1": {
                    "type": "string",
                    "description": "The street associated with the Address . Minimum length is 1 character."
                  },
                  "address2": {
                    "type": "string",
                    "description": "Any additional information associated with the shipping address."
                  },
                  "city": {
                    "type": "string",
                    "description": "The city associated with the shipping address."
                  },
                  "company": {
                    "type": "string",
                    "description": "The company associated with the shipping address."
                  },
                  "country_code": {
                    "type": "string",
                    "description": "2-letter country code."
                  },
                  "first_name": {
                    "type": "string",
                    "description": "The customer’s first name associated with the address. Minimum length is 1 character."
                  },
                  "last_name": {
                    "type": "string",
                    "description": "The customer’s last name associated with the address. Minimum length is 1 character."
                  },
                  "order_attributes": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "properties": {
                        "name": {
                          "type": "string",
                          "description": "The name for the attribute."
                        },
                        "value": {
                          "type": "string",
                          "description": "The value for the associated attribute."
                        }
                      }
                    },
                    "description": "Extra information that is added to the order."
                  },
                  "order_note": {
                    "type": "string",
                    "description": "Notes to be added to all orders associated with the address."
                  },
                  "payment_method_id": {
                    "type": "integer",
                    "description": "Payment method id for the Payment_method to be associated to this address."
                  },
                  "phone": {
                    "type": "string",
                    "description": "The phone number associated with the address. Must be included in the request schema but can be an empty string."
                  },
                  "presentment_currency": {
                    "type": "string",
                    "description": "The currency that charges on this address will be processed in. If no presentment_currency is passed, it will be set to your default store currency."
                  },
                  "province": {
                    "type": "string",
                    "description": "The state or province associated with the address. Check if country requires a province COUNTRIES_REQUIRING_PROVINCE ."
                  },
                  "shipping_lines_override": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "properties": {
                        "code": {
                          "type": "string",
                          "description": "The code of the associated shipping line."
                        },
                        "price": {
                          "type": "string",
                          "description": "The price (in store’s currency) of the associated shipping line."
                        },
                        "title": {
                          "type": "string",
                          "description": "The title of the associated shipping line."
                        }
                      }
                    },
                    "description": "Used when shipping rates need to be overridden. If this parameter has value null , rates will be fetched when a related Charge is created or regenerated"
                  },
                  "zip": {
                    "type": "string",
                    "description": "The zip or postal code associated with the address."
                  }
                },
                "required": [
                  "customer_id",
                  "address1",
                  "city",
                  "country_code",
                  "first_name",
                  "last_name",
                  "phone",
                  "province",
                  "zip"
                ]
              },
              "example": {
                "customer_id": 22152215,
                "address1": "1776 Washington Street",
                "address2": "",
                "city": "Los Angeles",
                "company": "Recharge",
                "country_code": "US",
                "first_name": "John",
                "last_name": "Doe",
                "order_attributes": [
                  {
                    "name": "custom name",
                    "value": "custom value"
                  }
                ],
                "phone": "5551234567",
                "presentment_currency": "USD",
                "province": "California",
                "zip": "90404"
              }
            }
          }
        },
        "x-recharge-scopes": [
          "write_customers"
        ]
      },
      "get": {
        "operationId": "list_addresses",
        "summary": "List addresses",
        "description": "Returns all addresses from the store, or addresses for the user given in the parameter. HTTP examples GET /addresses GET /addresses?customer_id=<customer_id> GET /addresses?discount_id=<discount_id> GET /addresses?discount_code=<discount_code>",
        "tags": [
          "Addresses"
        ],
        "parameters": [
          {
            "name": "created_at_max",
            "in": "query",
            "required": false,
            "description": "Returns addresses created before the given time.",
            "schema": {
              "type": "string",
              "format": "date-time"
            }
          },
          {
            "name": "created_at_min",
            "in": "query",
            "required": false,
            "description": "Returns addresses created after the given time.",
            "schema": {
              "type": "string",
              "format": "date-time"
            }
          },
          {
            "name": "customer_id",
            "in": "query",
            "required": false,
            "description": "Unique identifier of the customer.",
            "schema": {
              "type": "integer"
            }
          },
          {
            "name": "discount_code",
            "in": "query",
            "required": false,
            "description": "Returns addresses that have the provided discount_code.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "discount_id",
            "in": "query",
            "required": false,
            "description": "Returns addresses that have the provided discount_id.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "ids",
            "in": "query",
            "required": false,
            "description": "Filter addresses by id. If passing multiple values, must be comma separated. Non-integer values will result in a 422 error",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "description": "The amount of results. Default is 50 while the maximum is 250.",
            "schema": {
              "type": "string",
              "default": 50
            }
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "description": "The page to show. Default is 1.",
            "schema": {
              "type": "string",
              "deprecated": true,
              "default": 1
            }
          },
          {
            "name": "updated_at_max",
            "in": "query",
            "required": false,
            "description": "Returns addresses updated before the given date.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "updated_at_min",
            "in": "query",
            "required": false,
            "description": "Returns addresses updated after the given time.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "is_active",
            "in": "query",
            "required": false,
            "description": "Returns active addresses.",
            "schema": {
              "type": "boolean"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "addresses": [
                    {
                      "id": 42171447,
                      "payment_method_id": 17874235,
                      "address1": "1030 Barnum Ave",
                      "address2": "Suite 101",
                      "city": "Stratford",
                      "company": "Fake Company",
                      "country_code": "US",
                      "created_at": "2022-10-12T20:16:09+00:00",
                      "customer_id": 37657002,
                      "discounts": [
                        {
                          "id": 123456
                        }
                      ],
                      "first_name": "Fake First",
                      "last_name": "Fake Last",
                      "order_attributes": [
                        {
                          "name": "custom name",
                          "value": "custom value"
                        }
                      ],
                      "order_note": "My recurring order note",
                      "phone": "999-999-9999",
                      "presentment_currency": "USD",
                      "province": "Connecticut",
                      "shipping_lines_conserved": [],
                      "shipping_lines_override": [
                        {
                          "code": "Standard Shipping",
                          "price": "0.00",
                          "title": "Standard Shipping"
                        }
                      ],
                      "updated_at": "2022-10-12T20:16:09+00:00",
                      "zip": "06614"
                    }
                  ]
                }
              }
            }
          }
        },
        "x-recharge-scopes": [
          "read_customers"
        ]
      }
    },
    "/addresses/{id}": {
      "get": {
        "operationId": "retrieve_address",
        "summary": "Retrieve an address",
        "description": "Retrieves address for customer based on specified address id.",
        "tags": [
          "Addresses"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "address": {
                    "id": 42171447,
                    "payment_method_id": 17874235,
                    "address1": "1030 Barnum Ave",
                    "address2": "Suite 101",
                    "city": "Stratford",
                    "company": "Fake Company",
                    "country_code": "US",
                    "created_at": "2022-10-12T20:16:09+00:00",
                    "customer_id": 37657002,
                    "discounts": [],
                    "first_name": "Fake First",
                    "last_name": "Fake Last",
                    "order_attributes": [
                      {
                        "name": "custom name",
                        "value": "custom value"
                      }
                    ],
                    "order_note": "My recurring order note",
                    "phone": "999-999-9999",
                    "presentment_currency": "USD",
                    "province": "Connecticut",
                    "shipping_lines_conserved": [],
                    "shipping_lines_override": [],
                    "updated_at": "2022-10-12T20:16:09+00:00",
                    "zip": "06614"
                  }
                }
              }
            }
          }
        },
        "x-recharge-scopes": [
          "read_customers"
        ]
      },
      "put": {
        "operationId": "update_address",
        "summary": "Update an address",
        "description": "Updates an existing address to match the specified parameters. Example: remove discounts from an address To remove all discounts from an address, set the discounts parameter to an empty array: {\"discounts\": []}",
        "tags": [
          "Addresses"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "address": {
                    "id": 42171447,
                    "payment_method_id": 17874235,
                    "address1": "1030 Barnum Ave",
                    "address2": "Suite 101",
                    "city": "Stratford",
                    "company": "Fake Company",
                    "country_code": "US",
                    "created_at": "2022-10-12T20:16:09+00:00",
                    "customer_id": 37657002,
                    "discounts": [],
                    "first_name": "Fake First",
                    "last_name": "Fake Last",
                    "order_attributes": [
                      {
                        "name": "custom name",
                        "value": "custom value"
                      }
                    ],
                    "order_note": "My recurring order note",
                    "phone": "999-999-9999",
                    "presentment_currency": "USD",
                    "province": "Connecticut",
                    "shipping_lines_conserved": [],
                    "shipping_lines_override": [],
                    "updated_at": "2022-10-12T20:16:09+00:00",
                    "zip": "06614"
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "address1": {
                    "type": "string",
                    "description": "The street associated with the Address . Minimum length is 1 character."
                  },
                  "address2": {
                    "type": "string",
                    "description": "Any additional information associated with the shipping address."
                  },
                  "city": {
                    "type": "string",
                    "description": "The city associated with the shipping address. Minimum length is 1 character."
                  },
                  "company": {
                    "type": "string",
                    "description": "The company associated with the shipping address."
                  },
                  "country_code": {
                    "type": "string",
                    "description": "2-letter country code."
                  },
                  "discounts": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "properties": {
                        "id": {
                          "type": "integer",
                          "description": "The id of a discount associated with this address."
                        }
                      }
                    },
                    "description": "A discount which will be applied on the address. While the discounts parameter is an array, only a single discount code will be applied. If multiple discount codes are provided, only the first discount in the array will apply to the address."
                  },
                  "first_name": {
                    "type": "string",
                    "description": "The customer’s first name associated with the address. Minimum length is 1 character."
                  },
                  "last_name": {
                    "type": "string",
                    "description": "The customer’s last name associated with the address. Minimum length is 1 character."
                  },
                  "order_attributes": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "properties": {
                        "name": {
                          "type": "string",
                          "description": "The name for the attribute."
                        },
                        "value": {
                          "type": "string",
                          "description": "The value for the associated attribute."
                        }
                      }
                    },
                    "description": "Extra information that is added to the order."
                  },
                  "order_note": {
                    "type": "string",
                    "description": "Notes to be added to all orders associated with the address."
                  },
                  "payment_method_id": {
                    "type": "integer",
                    "description": "Payment method id for the Payment_method to be associated to this address."
                  },
                  "phone": {
                    "type": "string",
                    "description": "The phone number associated with the address. Must be included in the request schema but can be an empty string."
                  },
                  "province": {
                    "type": "string",
                    "description": "The state or province associated with the address. Check if country requires a province COUNTRIES_REQUIRING_PROVINCE ."
                  },
                  "shipping_lines_override": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "properties": {
                        "code": {
                          "type": "string",
                          "description": "The code of the associated shipping line."
                        },
                        "price": {
                          "type": "string",
                          "description": "The price (in store’s currency) of the associated shipping line."
                        },
                        "title": {
                          "type": "string",
                          "description": "The title of the associated shipping line."
                        }
                      }
                    },
                    "description": "Used when shipping rates need to be overridden. If this parameter has value null , rates will be fetched when a related Charge is created or regenerated."
                  },
                  "zip": {
                    "type": "string",
                    "description": "The zip or postal code associated with the address. Check if the country requires a zip code COUNTRIES_NOT_REQUIRING_ZIP . If not included in the list then a zip code with the minimum length of 1 character is required. If the country is United States then validate against regex UNITED_STATES_ZIP_REGEX . If country is United Kingdom then validate against regex UNITED_KINGDOM_ZIP_REGEX ."
                  }
                }
              },
              "example": {
                "address1": "1776 Washington Street"
              }
            }
          }
        },
        "x-recharge-scopes": [
          "write_customers"
        ]
      },
      "delete": {
        "operationId": "delete_address",
        "summary": "Delete an address",
        "description": "It is possible to delete certain addresses from the store using API.",
        "tags": [
          "Addresses"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "Content Deleted: The server has successfully fulfilled the request and deleted the desired object and there is no content to send in the response body.",
            "content": {
              "application/json": {
                "example": {}
              }
            }
          }
        },
        "x-recharge-scopes": [
          "write_customers"
        ]
      }
    },
    "/addresses/merge": {
      "post": {
        "operationId": "merge_addresses",
        "summary": "Merge addresses",
        "description": "Merges up to 10 source addresses into 1 target address.",
        "tags": [
          "Addresses"
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "address": {
                    "id": 42171447,
                    "payment_method_id": 17874235,
                    "address1": "1030 Barnum Ave",
                    "address2": "Suite 101",
                    "city": "Stratford",
                    "company": "Fake Company",
                    "country_code": "US",
                    "created_at": "2022-10-12T20:16:09+00:00",
                    "customer_id": 37657002,
                    "discounts": [],
                    "first_name": "Fake First",
                    "last_name": "Fake Last",
                    "order_attributes": [
                      {
                        "name": "custom name",
                        "value": "custom value"
                      }
                    ],
                    "order_note": "My recurring order note",
                    "phone": "999-999-9999",
                    "presentment_currency": "USD",
                    "province": "Connecticut",
                    "shipping_lines_conserved": [],
                    "shipping_lines_override": [],
                    "updated_at": "2022-10-12T20:16:09+00:00",
                    "zip": "06614"
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "delete_source_addresses": {
                    "type": "boolean",
                    "description": "Indicates whether source addresses should be deleted."
                  },
                  "next_charge_date": {
                    "type": "string",
                    "description": "Specifies the next charge date of the associated subscriptions on the target address."
                  },
                  "target_address": {
                    "type": "object",
                    "properties": {
                      "id": {
                        "type": "integer",
                        "description": "The id of the address."
                      }
                    },
                    "description": "The address all of the subscriptions should be moved to."
                  },
                  "source_addresses": {
                    "type": "array",
                    "items": {},
                    "description": "The list of addresses that the subscriptions should move from."
                  }
                },
                "required": [
                  "target_address",
                  "source_addresses"
                ]
              },
              "example": {
                "target_address": {
                  "id": 42171447
                },
                "source_addresses": [
                  {
                    "id": 42171446
                  },
                  {
                    "id": 42171445
                  }
                ]
              }
            }
          }
        },
        "x-recharge-scopes": [
          "write_customers"
        ]
      }
    },
    "/addresses/{id}/charges/skip": {
      "post": {
        "operationId": "skip_future_charge_address",
        "summary": "Skip future charge",
        "description": "Skip a Charge in the future for one or multiple Subscriptions associated with the Address .",
        "tags": [
          "Addresses"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "charge": {
                    "id": 377749210,
                    "address_id": 42171447,
                    "analytics_data": {
                      "utm_params": [
                        {
                          "utm_source": "facebook",
                          "utm_medium": "cpc"
                        }
                      ]
                    },
                    "billing_address": {
                      "address1": "601 SW Washing St.",
                      "address2": "Suite 101",
                      "city": "Portland",
                      "company": "Acme Corp",
                      "country_code": "US",
                      "first_name": "Jane",
                      "last_name": "Doe",
                      "phone": "888-888-8888",
                      "province": "Oregon",
                      "zip": "97205"
                    },
                    "client_details": {
                      "browser_ip": "192.168.0.1",
                      "user_agent": "safari webkit"
                    },
                    "created_at": "2021-11-09T19:22:13+00:00",
                    "currency": "USD",
                    "customer": {
                      "id": 37657002,
                      "email": "test@test.com",
                      "external_customer_id": {
                        "ecommerce": "2879413682227"
                      },
                      "hash": "7e706455cbd13e40"
                    },
                    "discounts": [
                      {
                        "id": 12345,
                        "code": "TESTCODE10",
                        "value": 10,
                        "value_type": "fixed_amount"
                      }
                    ],
                    "error": null,
                    "error_type": null,
                    "external_order_id": {
                      "ecommerce": "2541635698739"
                    },
                    "external_transaction_id": {
                      "payment_processor": "ch_1HzWElJ2zqHvZRd1TWKFFqDR"
                    },
                    "has_uncommitted_changes": false,
                    "line_items": [
                      {
                        "purchase_item_id": 63898947,
                        "external_product_id": {
                          "ecommerce": "4381728735283"
                        },
                        "external_variant_id": {
                          "ecommerce": "999999999999"
                        },
                        "grams": 454,
                        "handle": "shirt-package",
                        "images": {
                          "large": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_large.jpg",
                          "medium": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_medium.jpg",
                          "original": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h.jpg",
                          "small": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_small.jpg"
                        },
                        "original_price": "10.00",
                        "properties": [
                          {
                            "name": "Color",
                            "value": "Blue"
                          }
                        ],
                        "purchase_item_type": "subscription",
                        "quantity": 1,
                        "sku": "TOM0001",
                        "tax_due": "1.30",
                        "tax_lines": [
                          {
                            "price": "0.9931",
                            "rate": "0.0725",
                            "title": "CA State Tax",
                            "unit_price": "0.3310"
                          },
                          {
                            "price": "0.3082",
                            "rate": "0.0225",
                            "title": "LA County Tax",
                            "unit_price": "0.1027"
                          }
                        ],
                        "taxable": true,
                        "taxable_amount": "10.00",
                        "title": "Shirt package",
                        "total_price": "11.30",
                        "unit_price": "10.00",
                        "unit_price_includes_tax": false,
                        "variant_title": "Blue T-shirt"
                      }
                    ],
                    "note": "next order in sequence 3",
                    "order_attributes": [
                      {
                        "name": "Checkout-Method",
                        "value": "delivery"
                      }
                    ],
                    "orders_count": 1,
                    "payment_processor": "stripe",
                    "processed_at": null,
                    "retry_date": null,
                    "scheduled_at": "2021-12-09",
                    "shipping_address": {
                      "address1": "1030 Barnum Ave",
                      "address2": "Suite 101",
                      "city": "Stratford",
                      "company": "Fake Company",
                      "country_code": "US",
                      "first_name": "Fake First",
                      "last_name": "Fake Last",
                      "phone": "999-999-9999",
                      "province": "Connecticut",
                      "zip": "06614"
                    },
                    "shipping_lines": [
                      {
                        "code": "Standard",
                        "price": "4.90",
                        "source": "shopify",
                        "taxable": true,
                        "tax_lines": [
                          {
                            "price": "0.355",
                            "rate": 0.0725,
                            "title": "CA State Tax"
                          },
                          {
                            "price": "0.110",
                            "rate": 0.0225,
                            "title": "Los Angeles  County Tax"
                          }
                        ],
                        "title": "Standard"
                      }
                    ],
                    "status": "skipped",
                    "subtotal_price": "10.00",
                    "tags": "Subscription, Subscription Recurring Order",
                    "tax_lines": [
                      {
                        "price": "0.950",
                        "rate": 0.0725,
                        "title": "CA State Tax"
                      },
                      {
                        "price": "0.335",
                        "rate": 0.0225,
                        "title": "Los Angeles  County Tax"
                      }
                    ],
                    "taxable": true,
                    "total_discounts": "10.0",
                    "total_line_items_price": "10.00",
                    "total_price": "11.29",
                    "total_refunds": "0.00",
                    "total_tax": "1.29",
                    "total_weight_grams": 454,
                    "type": "recurring",
                    "updated_at": "2021-11-09T23:59:32+00:00"
                  }
                }
              }
            }
          },
          "404": {
            "description": "the Address with id does not exist",
            "content": {
              "application/json": {
                "example": {
                  "error": "address not found"
                }
              }
            }
          },
          "422": {
            "description": "invalid data passed to the endpoint",
            "content": {
              "application/json": {
                "example": {
                  "errors": {
                    "date": [
                      "Date must be at least one day in the future"
                    ]
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "date": {
                    "type": "string",
                    "format": "date-time",
                    "description": "The date in the future of the Charge to be skipped."
                  },
                  "subscription_ids": {
                    "type": "array",
                    "items": {},
                    "description": "A list containing the Subscription IDs to be skipped."
                  }
                },
                "required": [
                  "date",
                  "subscription_ids"
                ]
              },
              "example": {
                "date": "2022-09-15",
                "purchase_item_ids": [
                  27363808,
                  27363809
                ]
              }
            }
          }
        },
        "x-recharge-scopes": [
          "write_orders"
        ]
      }
    },
    "/bundle_selections": {
      "get": {
        "operationId": "bundle_selection_list",
        "summary": "List bundle selections",
        "description": "Returns a list of BundleSelections . HTTP request examples GET /bundle_selections?purchase_item_ids=:purchase_item_id_1,:purchase_item_id_2 GET /bundle_selections?bundle_variant_ids=:bundle_variant_id_1,:bundle_variant_id_2 GET /bundle_selections?limit=1 GET /bundle_selections?limit=1&page=2 GET /bundle_selections?sort_by=updated_at-desc Returned BundleSelections are sorted descending by ID value by default.",
        "tags": [
          "Bundle Selections"
        ],
        "parameters": [
          {
            "name": "purchase_item_ids",
            "in": "query",
            "required": false,
            "description": "Filter BundleSelections by Subscription or Onetime ID.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "bundle_variant_ids",
            "in": "query",
            "required": false,
            "description": "Filter BundleSelections by BundleVariants .",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "description": "The amount of results.",
            "schema": {
              "type": "string",
              "default": 50
            }
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "description": "The page to show.",
            "schema": {
              "type": "string",
              "deprecated": true,
              "default": 1
            }
          },
          {
            "name": "sort_by",
            "in": "query",
            "required": false,
            "description": "Sort listed BundleSelections in a specific order. Available sort options: id-asc , id-desc , updated_at-asc , updated_at-desc .",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "active_purchase_items",
            "in": "query",
            "required": false,
            "description": "Bundle selections are not directly linked to Subscriptions. By default, the endpoint returns Bundle Selections, even those associated with cancelled subscriptions, unless the Bundle Selection has been deleted. To exclude cancelled subscriptions from your results, include active_purchase_items=true in your query.",
            "schema": {
              "type": "boolean"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "next_cursor": null,
                  "previous_cursor": null,
                  "bundle_selections": [
                    {
                      "id": 100714428,
                      "bundle_variant": 382417,
                      "purchase_item_id": 199820883,
                      "created_at": "2022-08-26T18:31:28+00:00",
                      "external_product_id": "7121697210548",
                      "external_variant_id": "41450875650228",
                      "items": [
                        {
                          "id": 541,
                          "collection_id": "287569608884",
                          "collection_source": "shopify",
                          "created_at": "2022-08-26T18:31:28+00:00",
                          "external_product_id": "7121693671604",
                          "external_variant_id": "41450853105844",
                          "quantity": 3,
                          "updated_at": "2022-08-26T18:52:41+00:00"
                        }
                      ],
                      "updated_at": "2022-08-26T18:31:28+00:00"
                    }
                  ]
                }
              }
            }
          }
        },
        "x-recharge-scopes": [
          "read_subscriptions"
        ]
      },
      "post": {
        "operationId": "bundle_selection_create",
        "summary": "Create a bundle selection",
        "description": "Create a BundleSelection .",
        "tags": [
          "Bundle Selections"
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "bundle_selection": {
                    "id": 100714428,
                    "bundle_variant": 382417,
                    "purchase_item_id": 199820883,
                    "created_at": "2022-08-26T18:31:28+00:00",
                    "external_product_id": "7121697210548",
                    "external_variant_id": "41450875650228",
                    "items": [
                      {
                        "id": 541,
                        "collection_id": "287569608884",
                        "collection_source": "shopify",
                        "created_at": "2022-08-26T18:31:28+00:00",
                        "external_product_id": "7121693671604",
                        "external_variant_id": "41450853105844",
                        "quantity": 3,
                        "updated_at": "2022-08-26T18:52:41+00:00"
                      }
                    ],
                    "updated_at": "2022-08-26T18:31:28+00:00"
                  }
                }
              }
            }
          },
          "422": {
            "description": "missing required field or invalid items passed",
            "content": {
              "application/json": {
                "example": {
                  "errors": {
                    "bundle_variant_id": [
                      "Bundle variant 41450853105840 does not exist"
                    ]
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "purchase_item_id": {
                    "type": "integer",
                    "description": "The ID of the PurchaseItem associated with the BundleSelection ."
                  },
                  "plan_id": {
                    "type": "integer",
                    "description": "A Recharge Plan ID. If provided in a dynamically-priced Bundle, the unit price of each product variant will be inferred from the plan associated with the ID; otherwise, it will be inferred from the plan with the greatest discount for each product in the selection. This is not used in fixed-priced Bundles."
                  },
                  "items": {
                    "type": "array",
                    "items": {
                      "type": "object",
                      "properties": {
                        "collection_id": {
                          "type": "string",
                          "description": "The collection id as it appears in the external e-commerce platform."
                        },
                        "collection_source": {
                          "type": "string",
                          "description": "The identifier of the external e-commerce platform."
                        },
                        "external_product_id": {
                          "type": "string",
                          "description": "The product id as it appears in the external e-commerce platform. This is the item which is going to be extracted when the Bundle is processed."
                        },
                        "external_variant_id": {
                          "type": "string",
                          "description": "The variant id as it appears in the external e-commerce platform. This is the item which is going to be extracted when the Bundle is processed."
                        },
                        "quantity": {
                          "type": "integer",
                          "description": "The quantity of this product."
                        }
                      }
                    },
                    "description": "A list of item objects, each containing information about a distinct product selected as part of the Bundle."
                  }
                },
                "required": [
                  "purchase_item_id",
                  "items"
                ]
              },
              "example": {
                "purchase_item_id": 199820883,
                "items": [
                  {
                    "collection_id": "287569608884",
                    "collection_source": "shopify",
                    "external_product_id": "7121693671604",
                    "external_variant_id": "41450853105844",
                    "quantity": 3
                  }
                ]
              }
            }
          }
        },
        "x-recharge-scopes": [
          "write_subscriptions"
        ]
      }
    },
    "/bundle_selections/{id}": {
      "get": {
        "operationId": "bundle_selection_retrieve",
        "summary": "Retrieve a bundle selection",
        "description": "Retrieve a BundleSelection using the bundle_selection_id .",
        "tags": [
          "Bundle Selections"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "bundle_selection": {
                    "id": 100714428,
                    "bundle_variant": 382417,
                    "purchase_item_id": 199820883,
                    "created_at": "2022-08-26T18:31:28+00:00",
                    "external_product_id": "7121697210548",
                    "external_variant_id": "41450875650228",
                    "items": [
                      {
                        "id": 541,
                        "collection_id": "287569608884",
                        "collection_source": "shopify",
                        "created_at": "2022-08-26T18:31:28+00:00",
                        "external_product_id": "7121693671604",
                        "external_variant_id": "41450853105844",
                        "quantity": 3,
                        "updated_at": "2022-08-26T18:52:41+00:00"
                      }
                    ],
                    "updated_at": "2022-08-26T18:31:28+00:00"
                  }
                }
              }
            }
          },
          "404": {
            "description": "the BundleSelection with bundle_selection_id does not exist",
            "content": {
              "application/json": {
                "example": {
                  "error": "Bundle Selection not found"
                }
              }
            }
          }
        },
        "x-recharge-scopes": [
          "read_subscriptions"
        ]
      },
      "put": {
        "operationId": "bundle_selection_update",
        "summary": "Update a bundle selection",
        "description": "Modify an existing BundleSelection to match the specified parameters.",
        "tags": [
          "Bundle Selections"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "bundle_selection": {
                    "id": 100714428,
                    "bundle_variant": 382417,
                    "purchase_item_id": 199820883,
                    "created_at": "2022-08-26T18:31:28+00:00",
                    "external_product_id": "7121697210548",
                    "external_variant_id": "41450875650228",
                    "items": [
                      {
                        "id": 541,
                        "collection_id": "287569608884",
                        "collection_source": "shopify",
                        "created_at": "2022-08-26T18:31:28+00:00",
                        "external_product_id": "7121693671604",
                        "external_variant_id": "41450853105844",
                        "quantity": 3,
                        "updated_at": "2022-08-26T18:52:41+00:00"
                      }
                    ],
                    "updated_at": "2022-08-26T18:31:28+00:00"
                  }
                }
              }
            }
          },
          "404": {
            "description": "the BundleSelection with bundle_selection_id does not exist",
            "content": {
              "application/json": {
                "example": {
                  "error": "Bundle Selection not found"
                }
              }
            }
          },
          "422": {
            "description": "invalid items passed",
            "content": {
              "application/json": {
                "example": {
                  "errors": {
                    "bundle_variant_id": [
                      "Bundle variant 41450853105840 not found"
                    ]
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "purchase_item_id": {
                    "type": "integer",
                    "description": "The ID of the PurchaseItem associated with the BundleSelection ."
                  },
                  "plan_id": {
                    "type": "integer",
                    "description": "A Recharge Plan ID. If provided in a dynamically-priced Bundle, the unit price of each product variant will be inferred from the plan associated with the ID; otherwise, it will be inferred from the plan with the greatest discount for each product in the selection. This is not used in fixed-priced Bundles."
                  },
                  "items": {
                    "type": "array",
                    "items": {},
                    "description": "A list of item objects, each containing information about a distinct product selected as part of the Bundle."
                  }
                }
              },
              "example": {
                "purchase_item_id": 199820883,
                "items": [
                  {
                    "collection_id": "287569608884",
                    "collection_source": "shopify",
                    "external_product_id": "7121693671604",
                    "external_variant_id": "41450853105844",
                    "quantity": 3
                  }
                ]
              }
            }
          }
        },
        "x-recharge-scopes": [
          "write_subscriptions"
        ]
      },
      "delete": {
        "operationId": "bundle_selection_delete",
        "summary": "Delete a bundle selection",
        "description": "Delete a BundleSelection",
        "tags": [
          "Bundle Selections"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "the BundleSelection has been removed and there is no content to send back in the response body.",
            "content": {
              "application/json": {
                "example": {}
              }
            }
          },
          "404": {
            "description": "the BundleSelection with id does not exist",
            "content": {
              "application/json": {
                "example": {
                  "error": "Bundle Selection not found"
                }
              }
            }
          }
        },
        "x-recharge-scopes": [
          "write_subscriptions"
        ]
      }
    },
    "/charges/{id}": {
      "get": {
        "operationId": "charge_retrieve",
        "summary": "Retrieve a charge",
        "description": "Retrieve a Charge using the charge_id .",
        "tags": [
          "Charges"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "charge": {
                    "id": 377749210,
                    "address_id": 42171447,
                    "analytics_data": {
                      "utm_params": [
                        {
                          "utm_source": "facebook",
                          "utm_medium": "cpc"
                        }
                      ]
                    },
                    "billing_address": {
                      "address1": "601 SW Washing St.",
                      "address2": "Suite 101",
                      "city": "Portland",
                      "company": "Acme Corp",
                      "country_code": "US",
                      "first_name": "Jane",
                      "last_name": "Doe",
                      "phone": "888-888-8888",
                      "province": "Oregon",
                      "zip": "97205"
                    },
                    "client_details": {
                      "browser_ip": "192.168.0.1",
                      "user_agent": "safari webkit"
                    },
                    "created_at": "2021-11-09T19:22:13+00:00",
                    "currency": "USD",
                    "customer": {
                      "id": 37657002,
                      "email": "test@test.com",
                      "external_customer_id": {
                        "ecommerce": "2879413682227"
                      },
                      "hash": "7e706455cbd13e40"
                    },
                    "discounts": [
                      {
                        "id": 12345,
                        "code": "TESTCODE10",
                        "value": 10,
                        "value_type": "fixed_amount"
                      }
                    ],
                    "error": null,
                    "error_type": null,
                    "external_order_id": {
                      "ecommerce": "2541635698739"
                    },
                    "external_transaction_id": {
                      "payment_processor": "ch_1HzWElJ2zqHvZRd1TWKFFqDR"
                    },
                    "has_uncommitted_changes": false,
                    "line_items": [
                      {
                        "purchase_item_id": 63898947,
                        "external_product_id": {
                          "ecommerce": "4381728735283"
                        },
                        "external_variant_id": {
                          "ecommerce": "999999999999"
                        },
                        "grams": 454,
                        "handle": "shirt-package",
                        "images": {
                          "large": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_large.jpg",
                          "medium": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_medium.jpg",
                          "original": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h.jpg",
                          "small": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_small.jpg"
                        },
                        "original_price": "10.00",
                        "properties": [
                          {
                            "name": "Color",
                            "value": "Blue"
                          }
                        ],
                        "purchase_item_type": "subscription",
                        "quantity": 1,
                        "sku": "TOM0001",
                        "tax_due": "1.30",
                        "tax_lines": [
                          {
                            "price": "0.9931",
                            "rate": "0.0725",
                            "title": "CA State Tax",
                            "unit_price": "0.3310"
                          },
                          {
                            "price": "0.3082",
                            "rate": "0.0225",
                            "title": "LA County Tax",
                            "unit_price": "0.1027"
                          }
                        ],
                        "taxable": true,
                        "taxable_amount": "10.00",
                        "title": "Shirt package",
                        "total_price": "11.30",
                        "unit_price": "10.00",
                        "unit_price_includes_tax": false,
                        "variant_title": "Blue T-shirt"
                      }
                    ],
                    "note": "next order in sequence 3",
                    "order_attributes": [
                      {
                        "name": "Checkout-Method",
                        "value": "delivery"
                      }
                    ],
                    "orders_count": 1,
                    "payment_processor": "stripe",
                    "processed_at": "2021-11-09T23:59:31+00:00",
                    "retry_date": "2021-01-01",
                    "scheduled_at": "2021-12-09",
                    "shipping_address": {
                      "address1": "1030 Barnum Ave",
                      "address2": "Suite 101",
                      "city": "Stratford",
                      "company": "Fake Company",
                      "country_code": "US",
                      "first_name": "Fake First",
                      "last_name": "Fake Last",
                      "phone": "999-999-9999",
                      "province": "Connecticut",
                      "zip": "06614"
                    },
                    "shipping_lines": [
                      {
                        "code": "Standard",
                        "price": "4.90",
                        "source": "shopify",
                        "taxable": true,
                        "tax_lines": [
                          {
                            "price": "0.355",
                            "rate": 0.0725,
                            "title": "CA State Tax"
                          },
                          {
                            "price": "0.110",
                            "rate": 0.0225,
                            "title": "Los Angeles  County Tax"
                          }
                        ],
                        "title": "Standard"
                      }
                    ],
                    "status": "success",
                    "subtotal_price": "10.00",
                    "tags": "Subscription, Subscription Recurring Order",
                    "tax_lines": [
                      {
                        "price": "0.950",
                        "rate": 0.0725,
                        "title": "CA State Tax"
                      },
                      {
                        "price": "0.335",
                        "rate": 0.0225,
                        "title": "Los Angeles  County Tax"
                      }
                    ],
                    "taxable": true,
                    "taxes_included": true,
                    "total_discounts": "10.0",
                    "total_line_items_price": "10.00",
                    "total_price": "11.29",
                    "total_refunds": "0.00",
                    "total_tax": "1.29",
                    "total_weight_grams": 454,
                    "type": "recurring",
                    "updated_at": "2021-11-09T23:59:32+00:00"
                  }
                }
              }
            }
          }
        },
        "x-recharge-scopes": [
          "read_orders"
        ]
      }
    },
    "/charges": {
      "get": {
        "operationId": "charge_list",
        "summary": "List charges",
        "description": "Returns a list of Charges . HTTP request examples GET /charges?address_id=:address_id GET /charges?created_at_min=2016-05-18&created_at_max=2016-06-18 GET /charges?customer_id=:customer_id GET /charges?discount_code=10PERCENTOFF GET /charges?discount_id=:discount_id GET /charges?external_order_id=:external_order_id GET /charges?ids=1123551,262667345,12341535 GET /charges?purchase_item_id=:purchase_item_id GET /charges?scheduled_at=2016-06-18 GET /charges?scheduled_at_min=2016-05-18&scheduled_at_max=2016-06-18 GET /charges?sort_by=id-desc GET /charges?status=queued GET /charges?status=queued,refunded,partially_refunded GET /charges?updated_at_min=2016-05-18&updated_at_max=2016-06-18 GET /charges?processed_at_min=2022-01-18&processed_at_max=2022-02-18",
        "tags": [
          "Charges"
        ],
        "parameters": [
          {
            "name": "address_id",
            "in": "query",
            "required": false,
            "description": "Filter Charges by Address .",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "created_at_max",
            "in": "query",
            "required": false,
            "description": "Show Charges created before the given date.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "created_at_min",
            "in": "query",
            "required": false,
            "description": "Show Charges created after the given date.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "customer_id",
            "in": "query",
            "required": false,
            "description": "Filter Charges by Customer .",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "discount_code",
            "in": "query",
            "required": false,
            "description": "List Charges that contain the given discount_code .",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "discount_id",
            "in": "query",
            "required": false,
            "description": "List Charges that contain the given discount_id .",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "external_order_id",
            "in": "query",
            "required": false,
            "description": "Filter Charges by the associated order ID in the external e-commerce platform.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "ids",
            "in": "query",
            "required": false,
            "description": "Filter Charges by ID.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "description": "The amount of results.",
            "schema": {
              "type": "string",
              "default": 50
            }
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "description": "The page to show.",
            "schema": {
              "type": "string",
              "deprecated": true,
              "default": 1
            }
          },
          {
            "name": "purchase_item_id",
            "in": "query",
            "required": false,
            "description": "Filter Charges by a Subscription or Onetime ID.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "purchase_item_ids",
            "in": "query",
            "required": false,
            "description": "Filter Charges by a comma-separated list of Subscription or Onetime IDs.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "scheduled_at",
            "in": "query",
            "required": false,
            "description": "Filter Charges by specific scheduled charge date.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "scheduled_at_max",
            "in": "query",
            "required": false,
            "description": "Show Charges scheduled to be processed before the given date.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "scheduled_at_min",
            "in": "query",
            "required": false,
            "description": "Show Charges scheduled to be processed after the given date.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "sort_by",
            "in": "query",
            "required": false,
            "description": "Sort listed Charges in a specific order. Available sort options: id-asc , id-desc , updated_at-asc , updated_at-desc , scheduled_at-asc , scheduled_at-desc .",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "status",
            "in": "query",
            "required": false,
            "description": "Filter charges by status. Available status: success , queued , error , refunded , partially_refunded , skipped , pending_manual_payment , pending .",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "updated_at_max",
            "in": "query",
            "required": false,
            "description": "Show charges updated before the given date.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "updated_at_min",
            "in": "query",
            "required": false,
            "description": "Show charges updated after the given date.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "processed_at_min",
            "in": "query",
            "required": false,
            "description": "Show charges processed after, and including, the given date.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "processed_at_max",
            "in": "query",
            "required": false,
            "description": "Show charges processed before, and including, the given date.",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "next": "next_cursor",
                  "previous": "previous_cursor",
                  "charges": [
                    {
                      "id": 377749210,
                      "address_id": 42171447,
                      "analytics_data": {
                        "utm_params": [
                          {
                            "utm_source": "facebook",
                            "utm_medium": "cpc"
                          }
                        ]
                      },
                      "billing_address": {
                        "address1": "601 SW Washing St.",
                        "address2": "Suite 101",
                        "city": "Portland",
                        "company": "Acme Corp",
                        "country_code": "US",
                        "first_name": "Jane",
                        "last_name": "Doe",
                        "phone": "888-888-8888",
                        "province": "Oregon",
                        "zip": "97205"
                      },
                      "client_details": {
                        "browser_ip": "192.168.0.1",
                        "user_agent": "safari webkit"
                      },
                      "created_at": "2021-11-09T19:22:13+00:00",
                      "currency": "USD",
                      "customer": {
                        "id": 37657002,
                        "email": "test@test.com",
                        "external_customer_id": {
                          "ecommerce": "2879413682227"
                        },
                        "hash": "7e706455cbd13e40"
                      },
                      "discounts": [
                        {
                          "id": 12345,
                          "code": "TESTCODE10",
                          "value": 10,
                          "value_type": "fixed_amount"
                        }
                      ],
                      "error": null,
                      "error_type": null,
                      "external_order_id": {
                        "ecommerce": "2541635698739"
                      },
                      "external_transaction_id": {
                        "payment_processor": "ch_1HzWElJ2zqHvZRd1TWKFFqDR"
                      },
                      "has_uncommitted_changes": false,
                      "line_items": [
                        {
                          "purchase_item_id": 63898947,
                          "external_product_id": {
                            "ecommerce": "4381728735283"
                          },
                          "external_variant_id": {
                            "ecommerce": "999999999999"
                          },
                          "grams": 454,
                          "handle": "shirt-package",
                          "images": {
                            "large": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_large.jpg",
                            "medium": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_medium.jpg",
                            "original": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h.jpg",
                            "small": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_small.jpg"
                          },
                          "original_price": "10.00",
                          "properties": [
                            {
                              "name": "Color",
                              "value": "Blue"
                            }
                          ],
                          "purchase_item_type": "subscription",
                          "quantity": 1,
                          "sku": "TOM0001",
                          "tax_due": "1.30",
                          "tax_lines": [
                            {
                              "price": "0.9931",
                              "rate": "0.0725",
                              "title": "CA State Tax",
                              "unit_price": "0.3310"
                            },
                            {
                              "price": "0.3082",
                              "rate": "0.0225",
                              "title": "LA County Tax",
                              "unit_price": "0.1027"
                            }
                          ],
                          "taxable": true,
                          "taxable_amount": "10.00",
                          "title": "Shirt package",
                          "total_price": "11.30",
                          "unit_price": "10.00",
                          "unit_price_includes_tax": false,
                          "variant_title": "Blue T-shirt"
                        }
                      ],
                      "note": "next order in sequence 3",
                      "order_attributes": [
                        {
                          "name": "Checkout-Method",
                          "value": "delivery"
                        }
                      ],
                      "orders_count": 1,
                      "payment_processor": "stripe",
                      "processed_at": "2021-11-09T23:59:31+00:00",
                      "retry_date": "2021-01-01",
                      "scheduled_at": "2021-12-09",
                      "shipping_address": {
                        "address1": "1030 Barnum Ave",
                        "address2": "Suite 101",
                        "city": "Stratford",
                        "company": "Fake Company",
                        "country_code": "US",
                        "first_name": "Fake First",
                        "last_name": "Fake Last",
                        "phone": "999-999-9999",
                        "province": "Connecticut",
                        "zip": "06614"
                      },
                      "shipping_lines": [
                        {
                          "code": "Standard",
                          "price": "4.90",
                          "source": "shopify",
                          "taxable": true,
                          "tax_lines": [
                            {
                              "price": "0.355",
                              "rate": 0.0725,
                              "title": "CA State Tax"
                            },
                            {
                              "price": "0.110",
                              "rate": 0.0225,
                              "title": "Los Angeles  County Tax"
                            }
                          ],
                          "title": "Standard"
                        }
                      ],
                      "status": "success",
                      "subtotal_price": "10.00",
                      "tags": "Subscription, Subscription Recurring Order",
                      "tax_lines": [
                        {
                          "price": "0.950",
                          "rate": 0.0725,
                          "title": "CA State Tax"
                        },
                        {
                          "price": "0.335",
                          "rate": 0.0225,
                          "title": "Los Angeles  County Tax"
                        }
                      ],
                      "taxable": true,
                      "taxes_included": true,
                      "total_discounts": "10.0",
                      "total_line_items_price": "10.00",
                      "total_price": "11.29",
                      "total_refunds": "0.00",
                      "total_tax": "1.29",
                      "total_weight_grams": 454,
                      "type": "recurring",
                      "updated_at": "2021-11-09T23:59:32+00:00"
                    }
                  ]
                }
              }
            }
          }
        },
        "x-recharge-scopes": [
          "read_orders"
        ]
      }
    },
    "/charges/{id}/apply_discount": {
      "post": {
        "operationId": "apply_discount",
        "summary": "Apply a discount",
        "description": "Endpoint for adding Discount to an existing queued Charge .",
        "tags": [
          "Charges"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "charge": {
                    "id": 377749210,
                    "address_id": 42171447,
                    "analytics_data": {
                      "utm_params": [
                        {
                          "utm_source": "facebook",
                          "utm_medium": "cpc"
                        }
                      ]
                    },
                    "billing_address": {
                      "address1": "601 SW Washing St.",
                      "address2": "Suite 101",
                      "city": "Portland",
                      "company": "Acme Corp",
                      "country_code": "US",
                      "first_name": "Jane",
                      "last_name": "Doe",
                      "phone": "888-888-8888",
                      "province": "Oregon",
                      "zip": "97205"
                    },
                    "client_details": {
                      "browser_ip": "192.168.0.1",
                      "user_agent": "safari webkit"
                    },
                    "created_at": "2021-11-09T19:22:13+00:00",
                    "currency": "USD",
                    "customer": {
                      "id": 37657002,
                      "email": "test@test.com",
                      "external_customer_id": {
                        "ecommerce": "2879413682227"
                      },
                      "hash": "7e706455cbd13e40"
                    },
                    "discounts": [
                      {
                        "id": 12345,
                        "code": "TESTCODE10",
                        "value": 10,
                        "value_type": "fixed_amount"
                      }
                    ],
                    "error": null,
                    "error_type": null,
                    "external_order_id": {
                      "ecommerce": "2541635698739"
                    },
                    "external_transaction_id": {
                      "payment_processor": "ch_1HzWElJ2zqHvZRd1TWKFFqDR"
                    },
                    "has_uncommitted_changes": false,
                    "line_items": [
                      {
                        "purchase_item_id": 63898947,
                        "external_product_id": {
                          "ecommerce": "4381728735283"
                        },
                        "external_variant_id": {
                          "ecommerce": "999999999999"
                        },
                        "grams": 454,
                        "handle": "shirt-package",
                        "images": {
                          "large": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_large.jpg",
                          "medium": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_medium.jpg",
                          "original": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h.jpg",
                          "small": "https://example-cdn.com/s/files/1/0257/0351/4163/products/il_570xN.1723312095_a43h_small.jpg"
                        },
                        "original_price": "10.00",
                        "properties": [
                          {
                            "name": "Color",
                            "value": "Blue"
                          }
                        ],
                        "purchase_item_type": "subscription",
                        "quantity": 1,
                        "sku": "TOM0001",
                        "tax_due": "1.30",
                        "tax_lines": [
                          {
                            "price": "0.9931",
                            "rate": "0.0725",
                            "title": "CA State Tax",
                            "unit_price": "0.3310"
                          },
                          {
                            "price": "0.3082",
                            "rate": "0.0225",
                            "title": "LA County Tax",
                            "unit_price": "0.1027"
                          }
                        ],
                        "taxable": true,
                        "taxable_amount": "10.00",
                        "title": "Shirt package",
                        "total_price": "11.30",
                        "unit_price": "10.00",
                        "unit_price_includes_tax": false,
                        "variant_title": "Blue T-shirt"
                      }
                    ],
                    "note": "next order in sequence 3",
                    "order_attributes": [
                      {
                        "name": "Checkout-Method",
                        "value": "delivery"
                      }
                    ],
                    "orders_count": 1,
                    "payment_processor": "stripe",
                    "processed_at": "2021-11-09T23:59:31+00:00",
                    "retry_date": "2021-01-01",
                    "scheduled_at": "2021-12-09",
                    "shipping_address": {
                      "address1": "1030 Barnum Ave",
                      "address2": "Suite 101",
                      "city": "Stratford",
                      "company": "Fake Company",
                      "country_code": "US",
                      "first_name": "Fake First",
                      "last_name": "Fake Last",
                      "phone": "999-999-9999",
                      "province": "Connecticut",
                      "zip": "06614"
                    },
                    "shipping_lines": [
                      {
                        "code": "Standard",
                        "price": "4.90",
                        "source": "shopify",
                        "taxable": true,
                        "tax_lines": [
                          {
                            "price": "0.355",
                            "rate": 0.0725,
                            "title": "CA State Tax"
                          },
                          {
                            "price": "0.110",
                            "rate": 0.0225,
                            "title": "Los Angeles  County Tax"
                          }
                        ],
                        "title": "Standard"
                      }
                    ],
                    "status": "success",
                    "subtotal_price": "10.00",
                    "tags": "Subscription, Subscription Recurring Order",
                    "tax_lines": [
                      {
                        "price": "0.950",
                        "rate": 0.0725,
                        "title": "CA State Tax"
                      },
                      {
                        "price": "0.335",
                        "rate": 0.0225,
                        "title": "Los Angeles  County Tax"
                      }
                    ],
                    "taxable": true,
                    "total_discounts": "10.0",
                    "total_line_items_price": "10.00",
                    "total_price": "11.29",
                    "total_refunds": "0.00",
                    "total_tax": "1.29",
                    "total_weight_grams": 454,
                    "type": "recurring",
                    "updated_at": "2021-11-09T23:59:32+00:00"
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "discount_code": {
                    "type": "string",
                    "description": "Code of the Discount you want to apply to a Charge ."
                  },
                  "discount_id": {
                    "type": "integer",
                    "description": "ID of the Discount you want to apply to a Charge ."
                  }
                }
              },
              "example": {
                "discount_code": "test"
              }
            }
          }
        },
        "x-recharge-scopes": [
          "write_orders"
        ]
      }
    },
    "/charges/{id}/remove_discount": {
      "post": {
        "operationId": "remove_discount",
        "summary": "Remove a discount",
        "description": "Remove a Discount from a Charge without destroying the Discount . HTTP request examples POST /charges/<charge_id>/remove_discount/",
        "tags": [
          "Charges"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "successful response",
            "content": {
              "application/json": {
                "example": {
                  "charge": {
                    "id": 377749210,
                    "address_id": 42171447,
                    "analytics_data": {
                      "utm_params": [
                        {
                          "utm_source": "facebook",
                          "utm_medium": "cpc"
                        }
                      ]
                    },
                    "billing_address": {
                      "address1": "601 SW Washing St.",
                      "address2": "Suite 101",
                      "city": "Portland",
                      "company": "Acme Corp",
                      "country_code": "US",
                      "first_name": "Jane",
                      "last_name": "Doe",
                      "phone": "888-888-8888",
                      "province": "Oregon",
                      "zip": "97205"
                    },
                    "client_details": {
                      "browser_ip": "192.168.0.1",
                      "user_agent": "safari webkit"
                    },
                    "created_at": "2021-11-09T19:22:13+00:00",
                    "currency": "USD",
                    "customer": {
[...]
